<?php
	// Exit if accessed directly
	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}
	
	/**
	 * Страница лицензирования плагина.
	 *
	 * Поддерживает режим работы с мультисаймами. Вы можете увидеть эту страницу в панели настройки сети.
	 *
	 * @author        Alex Kovalev <alex.kovalevv@gmail.com>, Github: https://github.com/alexkovalevv
	 *
	 * @copyright (c) 2018 Webraftic Ltd
	 */
	class WCL_ComponentsLicensePage extends WCL_Page {
		
		/**
		 * {@inheritdoc}
		 *
		 * @author Alexander Kovalev <alex.kovalevv@gmail.com>
		 * @since  1.6.0
		 * @var string
		 */
		public $id = 'clearfy_components_license';
		
		/**
		 * {@inheritdoc}
		 *
		 * @var string
		 */
		public $type = 'page';
		
		/**
		 * {@inheritdoc}
		 *
		 * @author Alexander Kovalev <alex.kovalevv@gmail.com>
		 * @since  1.6.0
		 * @var string
		 */
		public $page_parent_page;
		
		/**
		 * @var int
		 */
		public $page_menu_position = 0;
		
		/**
		 * {@inheritdoc}
		 *
		 * @var bool
		 */
		public $show_right_sidebar_in_options = false;
		
		/**
		 * WCL_LicensePage constructor.
		 *
		 * @param \Wbcr_Factory428_Plugin $plugin
		 *
		 * @author Alexander Kovalev <alex.kovalevv@gmail.com>
		 *
		 */
		public function __construct( Wbcr_Factory428_Plugin $plugin ) {
			$this->menu_title                  = __( 'License', 'robin-image-optimizer' );
			$this->page_menu_short_description = __( 'Product activation', 'robin-image-optimizer' );
			$this->plan_name                   = __( 'Clearfy Business', 'robin-image-optimizer' );
			
			parent::__construct( $plugin );
		}
		
		/**
		 * Requests assets (js and css) for the page.
		 *
		 * @return void
		 * @since 1.0.0
		 * @see   FactoryPages428_AdminPage
		 *
		 */
		public function assets( $scripts, $styles ) {
			parent::assets( $scripts, $styles );
			
			$this->styles->add( WCL_PLUGIN_URL . '/admin/assets/css/components.css' );
			
			/**
			 * @param Wbcr_Factory428_StyleList $styles
			 * @param Wbcr_Factory428_ScriptList $scripts
			 *
			 * @since 1.4.0
			 *
			 */
			do_action( 'wbcr/clearfy/components/page_assets', $scripts, $styles );
		}
		
		/**
		 * This method simply show contents of the component page.
		 *
		 * @throws Exception
		 */
		public function showPageContent() {
			
			/**
			 * @since 1.4.0
			 *
			 */
			$components = apply_filters( 'wbcr/clearfy/license/list_components', [] );
			
		
		}
		
	}